// generated by "charlatan -dir=testdata/channeler -output=testdata/channeler/channeler.go Channeler".  DO NOT EDIT.

package main

import "reflect"

// ChannelerChannelInvocation represents a single call of FakeChanneler.Channel
type ChannelerChannelInvocation struct {
	Parameters struct {
		Ident1 chan int
	}
	Results struct {
		Ident2 chan int
	}
}

// NewChannelerChannelInvocation creates a new instance of ChannelerChannelInvocation
func NewChannelerChannelInvocation(ident1 chan int, ident2 chan int) *ChannelerChannelInvocation {
	invocation := new(ChannelerChannelInvocation)

	invocation.Parameters.Ident1 = ident1

	invocation.Results.Ident2 = ident2

	return invocation
}

// ChannelerChannelReceiveInvocation represents a single call of FakeChanneler.ChannelReceive
type ChannelerChannelReceiveInvocation struct {
	Parameters struct {
		Ident1 <-chan int
	}
	Results struct {
		Ident2 <-chan int
	}
}

// NewChannelerChannelReceiveInvocation creates a new instance of ChannelerChannelReceiveInvocation
func NewChannelerChannelReceiveInvocation(ident1 <-chan int, ident2 <-chan int) *ChannelerChannelReceiveInvocation {
	invocation := new(ChannelerChannelReceiveInvocation)

	invocation.Parameters.Ident1 = ident1

	invocation.Results.Ident2 = ident2

	return invocation
}

// ChannelerChannelSendInvocation represents a single call of FakeChanneler.ChannelSend
type ChannelerChannelSendInvocation struct {
	Parameters struct {
		Ident1 chan<- int
	}
	Results struct {
		Ident2 chan<- int
	}
}

// NewChannelerChannelSendInvocation creates a new instance of ChannelerChannelSendInvocation
func NewChannelerChannelSendInvocation(ident1 chan<- int, ident2 chan<- int) *ChannelerChannelSendInvocation {
	invocation := new(ChannelerChannelSendInvocation)

	invocation.Parameters.Ident1 = ident1

	invocation.Results.Ident2 = ident2

	return invocation
}

// ChannelerChannelPointerInvocation represents a single call of FakeChanneler.ChannelPointer
type ChannelerChannelPointerInvocation struct {
	Parameters struct {
		Ident1 *chan int
	}
	Results struct {
		Ident2 *chan int
	}
}

// NewChannelerChannelPointerInvocation creates a new instance of ChannelerChannelPointerInvocation
func NewChannelerChannelPointerInvocation(ident1 *chan int, ident2 *chan int) *ChannelerChannelPointerInvocation {
	invocation := new(ChannelerChannelPointerInvocation)

	invocation.Parameters.Ident1 = ident1

	invocation.Results.Ident2 = ident2

	return invocation
}

// ChannelerChannelInterfaceInvocation represents a single call of FakeChanneler.ChannelInterface
type ChannelerChannelInterfaceInvocation struct {
	Parameters struct {
		Ident1 chan interface{}
	}
	Results struct {
		Ident2 chan interface{}
	}
}

// NewChannelerChannelInterfaceInvocation creates a new instance of ChannelerChannelInterfaceInvocation
func NewChannelerChannelInterfaceInvocation(ident1 chan interface{}, ident2 chan interface{}) *ChannelerChannelInterfaceInvocation {
	invocation := new(ChannelerChannelInterfaceInvocation)

	invocation.Parameters.Ident1 = ident1

	invocation.Results.Ident2 = ident2

	return invocation
}

// ChannelerTestingT represents the methods of "testing".T used by charlatan Fakes.  It avoids importing the testing package.
type ChannelerTestingT interface {
	Error(...interface{})
	Errorf(string, ...interface{})
	Fatal(...interface{})
	Helper()
}

/*
FakeChanneler is a mock implementation of Channeler for testing.
Use it in your tests as in this example:

	package example

	func TestWithChanneler(t *testing.T) {
		f := &main.FakeChanneler{
			ChannelHook: func(ident1 chan int) (ident2 chan int) {
				// ensure parameters meet expections, signal errors using t, etc
				return
			},
		}

		// test code goes here ...

		// assert state of FakeChannel ...
		f.AssertChannelCalledOnce(t)
	}

Create anonymous function implementations for only those interface methods that
should be called in the code under test.  This will force a panic if any
unexpected calls are made to FakeChannel.
*/
type FakeChanneler struct {
	ChannelHook          func(chan int) chan int
	ChannelReceiveHook   func(<-chan int) <-chan int
	ChannelSendHook      func(chan<- int) chan<- int
	ChannelPointerHook   func(*chan int) *chan int
	ChannelInterfaceHook func(chan interface{}) chan interface{}

	ChannelCalls          []*ChannelerChannelInvocation
	ChannelReceiveCalls   []*ChannelerChannelReceiveInvocation
	ChannelSendCalls      []*ChannelerChannelSendInvocation
	ChannelPointerCalls   []*ChannelerChannelPointerInvocation
	ChannelInterfaceCalls []*ChannelerChannelInterfaceInvocation
}

// NewFakeChannelerDefaultPanic returns an instance of FakeChanneler with all hooks configured to panic
func NewFakeChannelerDefaultPanic() *FakeChanneler {
	return &FakeChanneler{
		ChannelHook: func(chan int) (ident2 chan int) {
			panic("Unexpected call to Channeler.Channel")
		},
		ChannelReceiveHook: func(<-chan int) (ident2 <-chan int) {
			panic("Unexpected call to Channeler.ChannelReceive")
		},
		ChannelSendHook: func(chan<- int) (ident2 chan<- int) {
			panic("Unexpected call to Channeler.ChannelSend")
		},
		ChannelPointerHook: func(*chan int) (ident2 *chan int) {
			panic("Unexpected call to Channeler.ChannelPointer")
		},
		ChannelInterfaceHook: func(chan interface{}) (ident2 chan interface{}) {
			panic("Unexpected call to Channeler.ChannelInterface")
		},
	}
}

// NewFakeChannelerDefaultFatal returns an instance of FakeChanneler with all hooks configured to call t.Fatal
func NewFakeChannelerDefaultFatal(t ChannelerTestingT) *FakeChanneler {
	return &FakeChanneler{
		ChannelHook: func(chan int) (ident2 chan int) {
			t.Fatal("Unexpected call to Channeler.Channel")
			return
		},
		ChannelReceiveHook: func(<-chan int) (ident2 <-chan int) {
			t.Fatal("Unexpected call to Channeler.ChannelReceive")
			return
		},
		ChannelSendHook: func(chan<- int) (ident2 chan<- int) {
			t.Fatal("Unexpected call to Channeler.ChannelSend")
			return
		},
		ChannelPointerHook: func(*chan int) (ident2 *chan int) {
			t.Fatal("Unexpected call to Channeler.ChannelPointer")
			return
		},
		ChannelInterfaceHook: func(chan interface{}) (ident2 chan interface{}) {
			t.Fatal("Unexpected call to Channeler.ChannelInterface")
			return
		},
	}
}

// NewFakeChannelerDefaultError returns an instance of FakeChanneler with all hooks configured to call t.Error
func NewFakeChannelerDefaultError(t ChannelerTestingT) *FakeChanneler {
	return &FakeChanneler{
		ChannelHook: func(chan int) (ident2 chan int) {
			t.Error("Unexpected call to Channeler.Channel")
			return
		},
		ChannelReceiveHook: func(<-chan int) (ident2 <-chan int) {
			t.Error("Unexpected call to Channeler.ChannelReceive")
			return
		},
		ChannelSendHook: func(chan<- int) (ident2 chan<- int) {
			t.Error("Unexpected call to Channeler.ChannelSend")
			return
		},
		ChannelPointerHook: func(*chan int) (ident2 *chan int) {
			t.Error("Unexpected call to Channeler.ChannelPointer")
			return
		},
		ChannelInterfaceHook: func(chan interface{}) (ident2 chan interface{}) {
			t.Error("Unexpected call to Channeler.ChannelInterface")
			return
		},
	}
}

func (f *FakeChanneler) Reset() {
	f.ChannelCalls = []*ChannelerChannelInvocation{}
	f.ChannelReceiveCalls = []*ChannelerChannelReceiveInvocation{}
	f.ChannelSendCalls = []*ChannelerChannelSendInvocation{}
	f.ChannelPointerCalls = []*ChannelerChannelPointerInvocation{}
	f.ChannelInterfaceCalls = []*ChannelerChannelInterfaceInvocation{}
}

func (_f1 *FakeChanneler) Channel(ident1 chan int) (ident2 chan int) {
	if _f1.ChannelHook == nil {
		panic("Channeler.Channel() called but FakeChanneler.ChannelHook is nil")
	}

	invocation := new(ChannelerChannelInvocation)
	_f1.ChannelCalls = append(_f1.ChannelCalls, invocation)

	invocation.Parameters.Ident1 = ident1

	ident2 = _f1.ChannelHook(ident1)

	invocation.Results.Ident2 = ident2

	return
}

// SetChannelStub configures Channeler.Channel to always return the given values
func (_f2 *FakeChanneler) SetChannelStub(ident2 chan int) {
	_f2.ChannelHook = func(chan int) chan int {
		return ident2
	}
}

// SetChannelInvocation configures Channeler.Channel to return the given results when called with the given parameters
// If no match is found for an invocation the result(s) of the fallback function are returned
func (_f3 *FakeChanneler) SetChannelInvocation(calls_f4 []*ChannelerChannelInvocation, fallback_f5 func() chan int) {
	_f3.ChannelHook = func(ident1 chan int) (ident2 chan int) {
		for _, call := range calls_f4 {
			if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
				ident2 = call.Results.Ident2

				return
			}
		}

		return fallback_f5()
	}
}

// ChannelCalled returns true if FakeChanneler.Channel was called
func (f *FakeChanneler) ChannelCalled() bool {
	return len(f.ChannelCalls) != 0
}

// AssertChannelCalled calls t.Error if FakeChanneler.Channel was not called
func (f *FakeChanneler) AssertChannelCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelCalls) == 0 {
		t.Error("FakeChanneler.Channel not called, expected at least one")
	}
}

// ChannelNotCalled returns true if FakeChanneler.Channel was not called
func (f *FakeChanneler) ChannelNotCalled() bool {
	return len(f.ChannelCalls) == 0
}

// AssertChannelNotCalled calls t.Error if FakeChanneler.Channel was called
func (f *FakeChanneler) AssertChannelNotCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelCalls) != 0 {
		t.Error("FakeChanneler.Channel called, expected none")
	}
}

// ChannelCalledOnce returns true if FakeChanneler.Channel was called exactly once
func (f *FakeChanneler) ChannelCalledOnce() bool {
	return len(f.ChannelCalls) == 1
}

// AssertChannelCalledOnce calls t.Error if FakeChanneler.Channel was not called exactly once
func (f *FakeChanneler) AssertChannelCalledOnce(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelCalls) != 1 {
		t.Errorf("FakeChanneler.Channel called %d times, expected 1", len(f.ChannelCalls))
	}
}

// ChannelCalledN returns true if FakeChanneler.Channel was called at least n times
func (f *FakeChanneler) ChannelCalledN(n int) bool {
	return len(f.ChannelCalls) >= n
}

// AssertChannelCalledN calls t.Error if FakeChanneler.Channel was called less than n times
func (f *FakeChanneler) AssertChannelCalledN(t ChannelerTestingT, n int) {
	t.Helper()
	if len(f.ChannelCalls) < n {
		t.Errorf("FakeChanneler.Channel called %d times, expected >= %d", len(f.ChannelCalls), n)
	}
}

// ChannelCalledWith returns true if FakeChanneler.Channel was called with the given values
func (_f6 *FakeChanneler) ChannelCalledWith(ident1 chan int) (found bool) {
	for _, call := range _f6.ChannelCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	return
}

// AssertChannelCalledWith calls t.Error if FakeChanneler.Channel was not called with the given values
func (_f7 *FakeChanneler) AssertChannelCalledWith(t ChannelerTestingT, ident1 chan int) {
	t.Helper()
	var found bool
	for _, call := range _f7.ChannelCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	if !found {
		t.Error("FakeChanneler.Channel not called with expected parameters")
	}
}

// ChannelCalledOnceWith returns true if FakeChanneler.Channel was called exactly once with the given values
func (_f8 *FakeChanneler) ChannelCalledOnceWith(ident1 chan int) bool {
	var count int
	for _, call := range _f8.ChannelCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	return count == 1
}

// AssertChannelCalledOnceWith calls t.Error if FakeChanneler.Channel was not called exactly once with the given values
func (_f9 *FakeChanneler) AssertChannelCalledOnceWith(t ChannelerTestingT, ident1 chan int) {
	t.Helper()
	var count int
	for _, call := range _f9.ChannelCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	if count != 1 {
		t.Errorf("FakeChanneler.Channel called %d times with expected parameters, expected one", count)
	}
}

// ChannelResultsForCall returns the result values for the first call to FakeChanneler.Channel with the given values
func (_f10 *FakeChanneler) ChannelResultsForCall(ident1 chan int) (ident2 chan int, found bool) {
	for _, call := range _f10.ChannelCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			ident2 = call.Results.Ident2
			found = true
			break
		}
	}

	return
}

func (_f11 *FakeChanneler) ChannelReceive(ident1 <-chan int) (ident2 <-chan int) {
	if _f11.ChannelReceiveHook == nil {
		panic("Channeler.ChannelReceive() called but FakeChanneler.ChannelReceiveHook is nil")
	}

	invocation := new(ChannelerChannelReceiveInvocation)
	_f11.ChannelReceiveCalls = append(_f11.ChannelReceiveCalls, invocation)

	invocation.Parameters.Ident1 = ident1

	ident2 = _f11.ChannelReceiveHook(ident1)

	invocation.Results.Ident2 = ident2

	return
}

// SetChannelReceiveStub configures Channeler.ChannelReceive to always return the given values
func (_f12 *FakeChanneler) SetChannelReceiveStub(ident2 <-chan int) {
	_f12.ChannelReceiveHook = func(<-chan int) <-chan int {
		return ident2
	}
}

// SetChannelReceiveInvocation configures Channeler.ChannelReceive to return the given results when called with the given parameters
// If no match is found for an invocation the result(s) of the fallback function are returned
func (_f13 *FakeChanneler) SetChannelReceiveInvocation(calls_f14 []*ChannelerChannelReceiveInvocation, fallback_f15 func() <-chan int) {
	_f13.ChannelReceiveHook = func(ident1 <-chan int) (ident2 <-chan int) {
		for _, call := range calls_f14 {
			if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
				ident2 = call.Results.Ident2

				return
			}
		}

		return fallback_f15()
	}
}

// ChannelReceiveCalled returns true if FakeChanneler.ChannelReceive was called
func (f *FakeChanneler) ChannelReceiveCalled() bool {
	return len(f.ChannelReceiveCalls) != 0
}

// AssertChannelReceiveCalled calls t.Error if FakeChanneler.ChannelReceive was not called
func (f *FakeChanneler) AssertChannelReceiveCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelReceiveCalls) == 0 {
		t.Error("FakeChanneler.ChannelReceive not called, expected at least one")
	}
}

// ChannelReceiveNotCalled returns true if FakeChanneler.ChannelReceive was not called
func (f *FakeChanneler) ChannelReceiveNotCalled() bool {
	return len(f.ChannelReceiveCalls) == 0
}

// AssertChannelReceiveNotCalled calls t.Error if FakeChanneler.ChannelReceive was called
func (f *FakeChanneler) AssertChannelReceiveNotCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelReceiveCalls) != 0 {
		t.Error("FakeChanneler.ChannelReceive called, expected none")
	}
}

// ChannelReceiveCalledOnce returns true if FakeChanneler.ChannelReceive was called exactly once
func (f *FakeChanneler) ChannelReceiveCalledOnce() bool {
	return len(f.ChannelReceiveCalls) == 1
}

// AssertChannelReceiveCalledOnce calls t.Error if FakeChanneler.ChannelReceive was not called exactly once
func (f *FakeChanneler) AssertChannelReceiveCalledOnce(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelReceiveCalls) != 1 {
		t.Errorf("FakeChanneler.ChannelReceive called %d times, expected 1", len(f.ChannelReceiveCalls))
	}
}

// ChannelReceiveCalledN returns true if FakeChanneler.ChannelReceive was called at least n times
func (f *FakeChanneler) ChannelReceiveCalledN(n int) bool {
	return len(f.ChannelReceiveCalls) >= n
}

// AssertChannelReceiveCalledN calls t.Error if FakeChanneler.ChannelReceive was called less than n times
func (f *FakeChanneler) AssertChannelReceiveCalledN(t ChannelerTestingT, n int) {
	t.Helper()
	if len(f.ChannelReceiveCalls) < n {
		t.Errorf("FakeChanneler.ChannelReceive called %d times, expected >= %d", len(f.ChannelReceiveCalls), n)
	}
}

// ChannelReceiveCalledWith returns true if FakeChanneler.ChannelReceive was called with the given values
func (_f16 *FakeChanneler) ChannelReceiveCalledWith(ident1 <-chan int) (found bool) {
	for _, call := range _f16.ChannelReceiveCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	return
}

// AssertChannelReceiveCalledWith calls t.Error if FakeChanneler.ChannelReceive was not called with the given values
func (_f17 *FakeChanneler) AssertChannelReceiveCalledWith(t ChannelerTestingT, ident1 <-chan int) {
	t.Helper()
	var found bool
	for _, call := range _f17.ChannelReceiveCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	if !found {
		t.Error("FakeChanneler.ChannelReceive not called with expected parameters")
	}
}

// ChannelReceiveCalledOnceWith returns true if FakeChanneler.ChannelReceive was called exactly once with the given values
func (_f18 *FakeChanneler) ChannelReceiveCalledOnceWith(ident1 <-chan int) bool {
	var count int
	for _, call := range _f18.ChannelReceiveCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	return count == 1
}

// AssertChannelReceiveCalledOnceWith calls t.Error if FakeChanneler.ChannelReceive was not called exactly once with the given values
func (_f19 *FakeChanneler) AssertChannelReceiveCalledOnceWith(t ChannelerTestingT, ident1 <-chan int) {
	t.Helper()
	var count int
	for _, call := range _f19.ChannelReceiveCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	if count != 1 {
		t.Errorf("FakeChanneler.ChannelReceive called %d times with expected parameters, expected one", count)
	}
}

// ChannelReceiveResultsForCall returns the result values for the first call to FakeChanneler.ChannelReceive with the given values
func (_f20 *FakeChanneler) ChannelReceiveResultsForCall(ident1 <-chan int) (ident2 <-chan int, found bool) {
	for _, call := range _f20.ChannelReceiveCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			ident2 = call.Results.Ident2
			found = true
			break
		}
	}

	return
}

func (_f21 *FakeChanneler) ChannelSend(ident1 chan<- int) (ident2 chan<- int) {
	if _f21.ChannelSendHook == nil {
		panic("Channeler.ChannelSend() called but FakeChanneler.ChannelSendHook is nil")
	}

	invocation := new(ChannelerChannelSendInvocation)
	_f21.ChannelSendCalls = append(_f21.ChannelSendCalls, invocation)

	invocation.Parameters.Ident1 = ident1

	ident2 = _f21.ChannelSendHook(ident1)

	invocation.Results.Ident2 = ident2

	return
}

// SetChannelSendStub configures Channeler.ChannelSend to always return the given values
func (_f22 *FakeChanneler) SetChannelSendStub(ident2 chan<- int) {
	_f22.ChannelSendHook = func(chan<- int) chan<- int {
		return ident2
	}
}

// SetChannelSendInvocation configures Channeler.ChannelSend to return the given results when called with the given parameters
// If no match is found for an invocation the result(s) of the fallback function are returned
func (_f23 *FakeChanneler) SetChannelSendInvocation(calls_f24 []*ChannelerChannelSendInvocation, fallback_f25 func() chan<- int) {
	_f23.ChannelSendHook = func(ident1 chan<- int) (ident2 chan<- int) {
		for _, call := range calls_f24 {
			if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
				ident2 = call.Results.Ident2

				return
			}
		}

		return fallback_f25()
	}
}

// ChannelSendCalled returns true if FakeChanneler.ChannelSend was called
func (f *FakeChanneler) ChannelSendCalled() bool {
	return len(f.ChannelSendCalls) != 0
}

// AssertChannelSendCalled calls t.Error if FakeChanneler.ChannelSend was not called
func (f *FakeChanneler) AssertChannelSendCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelSendCalls) == 0 {
		t.Error("FakeChanneler.ChannelSend not called, expected at least one")
	}
}

// ChannelSendNotCalled returns true if FakeChanneler.ChannelSend was not called
func (f *FakeChanneler) ChannelSendNotCalled() bool {
	return len(f.ChannelSendCalls) == 0
}

// AssertChannelSendNotCalled calls t.Error if FakeChanneler.ChannelSend was called
func (f *FakeChanneler) AssertChannelSendNotCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelSendCalls) != 0 {
		t.Error("FakeChanneler.ChannelSend called, expected none")
	}
}

// ChannelSendCalledOnce returns true if FakeChanneler.ChannelSend was called exactly once
func (f *FakeChanneler) ChannelSendCalledOnce() bool {
	return len(f.ChannelSendCalls) == 1
}

// AssertChannelSendCalledOnce calls t.Error if FakeChanneler.ChannelSend was not called exactly once
func (f *FakeChanneler) AssertChannelSendCalledOnce(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelSendCalls) != 1 {
		t.Errorf("FakeChanneler.ChannelSend called %d times, expected 1", len(f.ChannelSendCalls))
	}
}

// ChannelSendCalledN returns true if FakeChanneler.ChannelSend was called at least n times
func (f *FakeChanneler) ChannelSendCalledN(n int) bool {
	return len(f.ChannelSendCalls) >= n
}

// AssertChannelSendCalledN calls t.Error if FakeChanneler.ChannelSend was called less than n times
func (f *FakeChanneler) AssertChannelSendCalledN(t ChannelerTestingT, n int) {
	t.Helper()
	if len(f.ChannelSendCalls) < n {
		t.Errorf("FakeChanneler.ChannelSend called %d times, expected >= %d", len(f.ChannelSendCalls), n)
	}
}

// ChannelSendCalledWith returns true if FakeChanneler.ChannelSend was called with the given values
func (_f26 *FakeChanneler) ChannelSendCalledWith(ident1 chan<- int) (found bool) {
	for _, call := range _f26.ChannelSendCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	return
}

// AssertChannelSendCalledWith calls t.Error if FakeChanneler.ChannelSend was not called with the given values
func (_f27 *FakeChanneler) AssertChannelSendCalledWith(t ChannelerTestingT, ident1 chan<- int) {
	t.Helper()
	var found bool
	for _, call := range _f27.ChannelSendCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	if !found {
		t.Error("FakeChanneler.ChannelSend not called with expected parameters")
	}
}

// ChannelSendCalledOnceWith returns true if FakeChanneler.ChannelSend was called exactly once with the given values
func (_f28 *FakeChanneler) ChannelSendCalledOnceWith(ident1 chan<- int) bool {
	var count int
	for _, call := range _f28.ChannelSendCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	return count == 1
}

// AssertChannelSendCalledOnceWith calls t.Error if FakeChanneler.ChannelSend was not called exactly once with the given values
func (_f29 *FakeChanneler) AssertChannelSendCalledOnceWith(t ChannelerTestingT, ident1 chan<- int) {
	t.Helper()
	var count int
	for _, call := range _f29.ChannelSendCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	if count != 1 {
		t.Errorf("FakeChanneler.ChannelSend called %d times with expected parameters, expected one", count)
	}
}

// ChannelSendResultsForCall returns the result values for the first call to FakeChanneler.ChannelSend with the given values
func (_f30 *FakeChanneler) ChannelSendResultsForCall(ident1 chan<- int) (ident2 chan<- int, found bool) {
	for _, call := range _f30.ChannelSendCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			ident2 = call.Results.Ident2
			found = true
			break
		}
	}

	return
}

func (_f31 *FakeChanneler) ChannelPointer(ident1 *chan int) (ident2 *chan int) {
	if _f31.ChannelPointerHook == nil {
		panic("Channeler.ChannelPointer() called but FakeChanneler.ChannelPointerHook is nil")
	}

	invocation := new(ChannelerChannelPointerInvocation)
	_f31.ChannelPointerCalls = append(_f31.ChannelPointerCalls, invocation)

	invocation.Parameters.Ident1 = ident1

	ident2 = _f31.ChannelPointerHook(ident1)

	invocation.Results.Ident2 = ident2

	return
}

// SetChannelPointerStub configures Channeler.ChannelPointer to always return the given values
func (_f32 *FakeChanneler) SetChannelPointerStub(ident2 *chan int) {
	_f32.ChannelPointerHook = func(*chan int) *chan int {
		return ident2
	}
}

// SetChannelPointerInvocation configures Channeler.ChannelPointer to return the given results when called with the given parameters
// If no match is found for an invocation the result(s) of the fallback function are returned
func (_f33 *FakeChanneler) SetChannelPointerInvocation(calls_f34 []*ChannelerChannelPointerInvocation, fallback_f35 func() *chan int) {
	_f33.ChannelPointerHook = func(ident1 *chan int) (ident2 *chan int) {
		for _, call := range calls_f34 {
			if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
				ident2 = call.Results.Ident2

				return
			}
		}

		return fallback_f35()
	}
}

// ChannelPointerCalled returns true if FakeChanneler.ChannelPointer was called
func (f *FakeChanneler) ChannelPointerCalled() bool {
	return len(f.ChannelPointerCalls) != 0
}

// AssertChannelPointerCalled calls t.Error if FakeChanneler.ChannelPointer was not called
func (f *FakeChanneler) AssertChannelPointerCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelPointerCalls) == 0 {
		t.Error("FakeChanneler.ChannelPointer not called, expected at least one")
	}
}

// ChannelPointerNotCalled returns true if FakeChanneler.ChannelPointer was not called
func (f *FakeChanneler) ChannelPointerNotCalled() bool {
	return len(f.ChannelPointerCalls) == 0
}

// AssertChannelPointerNotCalled calls t.Error if FakeChanneler.ChannelPointer was called
func (f *FakeChanneler) AssertChannelPointerNotCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelPointerCalls) != 0 {
		t.Error("FakeChanneler.ChannelPointer called, expected none")
	}
}

// ChannelPointerCalledOnce returns true if FakeChanneler.ChannelPointer was called exactly once
func (f *FakeChanneler) ChannelPointerCalledOnce() bool {
	return len(f.ChannelPointerCalls) == 1
}

// AssertChannelPointerCalledOnce calls t.Error if FakeChanneler.ChannelPointer was not called exactly once
func (f *FakeChanneler) AssertChannelPointerCalledOnce(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelPointerCalls) != 1 {
		t.Errorf("FakeChanneler.ChannelPointer called %d times, expected 1", len(f.ChannelPointerCalls))
	}
}

// ChannelPointerCalledN returns true if FakeChanneler.ChannelPointer was called at least n times
func (f *FakeChanneler) ChannelPointerCalledN(n int) bool {
	return len(f.ChannelPointerCalls) >= n
}

// AssertChannelPointerCalledN calls t.Error if FakeChanneler.ChannelPointer was called less than n times
func (f *FakeChanneler) AssertChannelPointerCalledN(t ChannelerTestingT, n int) {
	t.Helper()
	if len(f.ChannelPointerCalls) < n {
		t.Errorf("FakeChanneler.ChannelPointer called %d times, expected >= %d", len(f.ChannelPointerCalls), n)
	}
}

// ChannelPointerCalledWith returns true if FakeChanneler.ChannelPointer was called with the given values
func (_f36 *FakeChanneler) ChannelPointerCalledWith(ident1 *chan int) (found bool) {
	for _, call := range _f36.ChannelPointerCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	return
}

// AssertChannelPointerCalledWith calls t.Error if FakeChanneler.ChannelPointer was not called with the given values
func (_f37 *FakeChanneler) AssertChannelPointerCalledWith(t ChannelerTestingT, ident1 *chan int) {
	t.Helper()
	var found bool
	for _, call := range _f37.ChannelPointerCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	if !found {
		t.Error("FakeChanneler.ChannelPointer not called with expected parameters")
	}
}

// ChannelPointerCalledOnceWith returns true if FakeChanneler.ChannelPointer was called exactly once with the given values
func (_f38 *FakeChanneler) ChannelPointerCalledOnceWith(ident1 *chan int) bool {
	var count int
	for _, call := range _f38.ChannelPointerCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	return count == 1
}

// AssertChannelPointerCalledOnceWith calls t.Error if FakeChanneler.ChannelPointer was not called exactly once with the given values
func (_f39 *FakeChanneler) AssertChannelPointerCalledOnceWith(t ChannelerTestingT, ident1 *chan int) {
	t.Helper()
	var count int
	for _, call := range _f39.ChannelPointerCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	if count != 1 {
		t.Errorf("FakeChanneler.ChannelPointer called %d times with expected parameters, expected one", count)
	}
}

// ChannelPointerResultsForCall returns the result values for the first call to FakeChanneler.ChannelPointer with the given values
func (_f40 *FakeChanneler) ChannelPointerResultsForCall(ident1 *chan int) (ident2 *chan int, found bool) {
	for _, call := range _f40.ChannelPointerCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			ident2 = call.Results.Ident2
			found = true
			break
		}
	}

	return
}

func (_f41 *FakeChanneler) ChannelInterface(ident1 chan interface{}) (ident2 chan interface{}) {
	if _f41.ChannelInterfaceHook == nil {
		panic("Channeler.ChannelInterface() called but FakeChanneler.ChannelInterfaceHook is nil")
	}

	invocation := new(ChannelerChannelInterfaceInvocation)
	_f41.ChannelInterfaceCalls = append(_f41.ChannelInterfaceCalls, invocation)

	invocation.Parameters.Ident1 = ident1

	ident2 = _f41.ChannelInterfaceHook(ident1)

	invocation.Results.Ident2 = ident2

	return
}

// SetChannelInterfaceStub configures Channeler.ChannelInterface to always return the given values
func (_f42 *FakeChanneler) SetChannelInterfaceStub(ident2 chan interface{}) {
	_f42.ChannelInterfaceHook = func(chan interface{}) chan interface{} {
		return ident2
	}
}

// SetChannelInterfaceInvocation configures Channeler.ChannelInterface to return the given results when called with the given parameters
// If no match is found for an invocation the result(s) of the fallback function are returned
func (_f43 *FakeChanneler) SetChannelInterfaceInvocation(calls_f44 []*ChannelerChannelInterfaceInvocation, fallback_f45 func() chan interface{}) {
	_f43.ChannelInterfaceHook = func(ident1 chan interface{}) (ident2 chan interface{}) {
		for _, call := range calls_f44 {
			if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
				ident2 = call.Results.Ident2

				return
			}
		}

		return fallback_f45()
	}
}

// ChannelInterfaceCalled returns true if FakeChanneler.ChannelInterface was called
func (f *FakeChanneler) ChannelInterfaceCalled() bool {
	return len(f.ChannelInterfaceCalls) != 0
}

// AssertChannelInterfaceCalled calls t.Error if FakeChanneler.ChannelInterface was not called
func (f *FakeChanneler) AssertChannelInterfaceCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelInterfaceCalls) == 0 {
		t.Error("FakeChanneler.ChannelInterface not called, expected at least one")
	}
}

// ChannelInterfaceNotCalled returns true if FakeChanneler.ChannelInterface was not called
func (f *FakeChanneler) ChannelInterfaceNotCalled() bool {
	return len(f.ChannelInterfaceCalls) == 0
}

// AssertChannelInterfaceNotCalled calls t.Error if FakeChanneler.ChannelInterface was called
func (f *FakeChanneler) AssertChannelInterfaceNotCalled(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelInterfaceCalls) != 0 {
		t.Error("FakeChanneler.ChannelInterface called, expected none")
	}
}

// ChannelInterfaceCalledOnce returns true if FakeChanneler.ChannelInterface was called exactly once
func (f *FakeChanneler) ChannelInterfaceCalledOnce() bool {
	return len(f.ChannelInterfaceCalls) == 1
}

// AssertChannelInterfaceCalledOnce calls t.Error if FakeChanneler.ChannelInterface was not called exactly once
func (f *FakeChanneler) AssertChannelInterfaceCalledOnce(t ChannelerTestingT) {
	t.Helper()
	if len(f.ChannelInterfaceCalls) != 1 {
		t.Errorf("FakeChanneler.ChannelInterface called %d times, expected 1", len(f.ChannelInterfaceCalls))
	}
}

// ChannelInterfaceCalledN returns true if FakeChanneler.ChannelInterface was called at least n times
func (f *FakeChanneler) ChannelInterfaceCalledN(n int) bool {
	return len(f.ChannelInterfaceCalls) >= n
}

// AssertChannelInterfaceCalledN calls t.Error if FakeChanneler.ChannelInterface was called less than n times
func (f *FakeChanneler) AssertChannelInterfaceCalledN(t ChannelerTestingT, n int) {
	t.Helper()
	if len(f.ChannelInterfaceCalls) < n {
		t.Errorf("FakeChanneler.ChannelInterface called %d times, expected >= %d", len(f.ChannelInterfaceCalls), n)
	}
}

// ChannelInterfaceCalledWith returns true if FakeChanneler.ChannelInterface was called with the given values
func (_f46 *FakeChanneler) ChannelInterfaceCalledWith(ident1 chan interface{}) (found bool) {
	for _, call := range _f46.ChannelInterfaceCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	return
}

// AssertChannelInterfaceCalledWith calls t.Error if FakeChanneler.ChannelInterface was not called with the given values
func (_f47 *FakeChanneler) AssertChannelInterfaceCalledWith(t ChannelerTestingT, ident1 chan interface{}) {
	t.Helper()
	var found bool
	for _, call := range _f47.ChannelInterfaceCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			found = true
			break
		}
	}

	if !found {
		t.Error("FakeChanneler.ChannelInterface not called with expected parameters")
	}
}

// ChannelInterfaceCalledOnceWith returns true if FakeChanneler.ChannelInterface was called exactly once with the given values
func (_f48 *FakeChanneler) ChannelInterfaceCalledOnceWith(ident1 chan interface{}) bool {
	var count int
	for _, call := range _f48.ChannelInterfaceCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	return count == 1
}

// AssertChannelInterfaceCalledOnceWith calls t.Error if FakeChanneler.ChannelInterface was not called exactly once with the given values
func (_f49 *FakeChanneler) AssertChannelInterfaceCalledOnceWith(t ChannelerTestingT, ident1 chan interface{}) {
	t.Helper()
	var count int
	for _, call := range _f49.ChannelInterfaceCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			count++
		}
	}

	if count != 1 {
		t.Errorf("FakeChanneler.ChannelInterface called %d times with expected parameters, expected one", count)
	}
}

// ChannelInterfaceResultsForCall returns the result values for the first call to FakeChanneler.ChannelInterface with the given values
func (_f50 *FakeChanneler) ChannelInterfaceResultsForCall(ident1 chan interface{}) (ident2 chan interface{}, found bool) {
	for _, call := range _f50.ChannelInterfaceCalls {
		if reflect.DeepEqual(call.Parameters.Ident1, ident1) {
			ident2 = call.Results.Ident2
			found = true
			break
		}
	}

	return
}
